=== debian/changelog ===
libfplus (0.2.13-2) unstable; urgency=medium

  * Team upload.
  * Configure with -DCMAKE_POLICY_VERSION_MINIMUM=3.5 (Closes: #1113151)

 -- Andrius Merkys <merkys@debian.org>  Thu, 02 Oct 2025 02:43:25 -0400

libfplus (0.2.13-1) unstable; urgency=low

  * Initial release (Closes: #986239).

 -- Filippo Rusconi <lopippo@debian.org>  Thu, 01 Apr 2021 12:08:45 +0200
