=== debian/control ===
Source: libfplus
Section: devel
Priority: optional
Maintainer: The Debichem Group <debichem-devel@lists.alioth.debian.org>
Uploaders: Filippo Rusconi <lopippo@debian.org>
Build-Depends: debhelper-compat (= 12),
 dh-exec (>= 0.3),
 dpkg-dev (>= 1.18.25),
 cmake,
 python3-docutils
Standards-Version: 4.5.1
Homepage: https://github.com/Dobiasd/FunctionalPlus
Vcs-Browser: https://salsa.debian.org/debichem-team/libfplus
Vcs-Git: https://salsa.debian.org/debichem-team/libfplus.git


Package: libfplus-dev
Section: libdevel
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Helps developers writing concise and readable C++ code (dev files)
 Great code should mostly be self-documenting, but while using C++ in reality
 you can find yourself dealing with low-level stuff like iterators or
 hand-written loops that distract from the actual essence of your code.
 . 
 FunctionalPlus is a small header-only library supporting you in reducing code
 noise and in dealing with only one single level of abstraction at a time. By
 increasing brevity and maintainability of your code it can improve
 productivity (and fun!) in the long run. It pursues these goals by providing
 pure and easy-to-use functions that free you from implementing commonly used
 flows of control over and over again.
 .
 This package ships this header-only library files.
